/*
 * This class is an auto-generated source file for a HAPI
 * HL7 v2.x standard structure class.
 *
 * For more information, visit: http://hl7api.sourceforge.net/
 */

package ca.uhn.hl7v2.model.v251.group;

import ca.uhn.hl7v2.model.v251.segment.*;

import ca.uhn.log.HapiLogFactory;
import ca.uhn.hl7v2.HL7Exception;
import ca.uhn.hl7v2.parser.ModelClassFactory;
import ca.uhn.hl7v2.parser.DefaultModelClassFactory;
import ca.uhn.hl7v2.model.AbstractMessage;
import ca.uhn.hl7v2.model.Group;
import ca.uhn.hl7v2.model.AbstractGroup;
import ca.uhn.hl7v2.model.GenericSegment;

/**
 * <p>Represents a OML_O33_ORDER_PRIOR group structure (a Group object).
 * A Group is an ordered collection of message segments that can repeat together or be optionally in/excluded together.
 * This Group contains the following elements:  
 * </p>
 * <ul>
                 * <li>1: ORC (Common Order) <b>optional </b></li>
                 * <li>2: OBR (Observation Request) <b> </b></li>
                 * <li>3: NTE (Notes and Comments) <b>optional repeating</b></li>
                 * <li>4: OML_O33_TIMING_PRIOR (a Group object) <b>optional repeating</b></li>
                 * <li>5: OML_O33_OBSERVATION_PRIOR (a Group object) <b> repeating</b></li>
 * </ul>
 */
public class OML_O33_ORDER_PRIOR extends AbstractGroup {

    /** 
     * Creates a new OML_O33_ORDER_PRIOR group
     */
    public OML_O33_ORDER_PRIOR(Group parent, ModelClassFactory factory) {
       super(parent, factory);
       init(factory);
    }

    private void init(ModelClassFactory factory) {
       try {
                          this.add(ORC.class, false, false);
                          this.add(OBR.class, true, false);
                          this.add(NTE.class, false, true);
                          this.add(OML_O33_TIMING_PRIOR.class, false, true);
                          this.add(OML_O33_OBSERVATION_PRIOR.class, true, true);
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error creating OML_O33_ORDER_PRIOR - this is probably a bug in the source code generator.", e);
       }
    }

    /** 
     * Returns "2.5.1"
     */
    public String getVersion() {
       return "2.5.1";
    }



    /**
     * Returns
     * ORC (Common Order) - creates it if necessary
     */
    public ORC getORC() { 
       ORC ret = null;
       try {
          ret = (ORC)this.get("ORC");
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error accessing data - this is probably a bug in the source code generator.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }




    /**
     * Returns
     * OBR (Observation Request) - creates it if necessary
     */
    public OBR getOBR() { 
       OBR ret = null;
       try {
          ret = (OBR)this.get("OBR");
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error accessing data - this is probably a bug in the source code generator.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }




    /**
     * Returns
     * the first repetition of 
     * NTE (Notes and Comments) - creates it if necessary
     */
    public NTE getNTE() { 
       NTE ret = null;
       try {
          ret = (NTE)this.get("NTE");
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error accessing data - this is probably a bug in the source code generator.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }


    /**
     * Returns a specific repetition of
     * NTE (Notes and Comments) - creates it if necessary
     *
     * @param rep The repetition index (0-indexed, i.e. the first repetition is at index 0)
     * @throws HL7Exception if the repetition requested is more than one 
     *     greater than the number of existing repetitions.
     */
    public NTE getNTE(int rep) { 
       NTE ret = null;
       try {
          ret = (NTE)this.get("NTE", rep);
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error accessing data - this is probably a bug in the source code generator.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }

    /** 
     * Returns the number of existing repetitions of NTE 
     */ 
    public int getNTEReps() { 
        int reps = -1; 
        try { 
            reps = this.getAll("NTE").length; 
        } catch (HL7Exception e) { 
            String message = "Unexpected error accessing data - this is probably a bug in the source code generator."; 
            HapiLogFactory.getHapiLog(this.getClass()).error(message, e); 
            throw new RuntimeException(message);
        } 
        return reps; 
    } 

    /**
     * Inserts a specific repetition of NTE (Notes and Comments)
     * @see AbstractGroup#insertRepetition(Structure, int) 
     */
    public void insertNTE(NTE structure, int rep) throws HL7Exception { 
       super.insertRepetition("NTE", structure, rep);
    }


    /**
     * Inserts a specific repetition of NTE (Notes and Comments)
     * @see AbstractGroup#insertRepetition(Structure, int) 
     */
    public NTE insertNTE(int rep) throws HL7Exception { 
       return (NTE)super.insertRepetition("NTE", rep);
    }


    /**
     * Removes a specific repetition of NTE (Notes and Comments)
     * @see AbstractGroup#removeRepetition(String, int) 
     */
    public NTE removeNTE(int rep) throws HL7Exception { 
       return (NTE)super.removeRepetition("NTE", rep);
    }



    /**
     * Returns
     * the first repetition of 
     * TIMING_PRIOR (a Group object) - creates it if necessary
     */
    public OML_O33_TIMING_PRIOR getTIMING_PRIOR() { 
       OML_O33_TIMING_PRIOR ret = null;
       try {
          ret = (OML_O33_TIMING_PRIOR)this.get("TIMING_PRIOR");
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error accessing data - this is probably a bug in the source code generator.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }


    /**
     * Returns a specific repetition of
     * TIMING_PRIOR (a Group object) - creates it if necessary
     *
     * @param rep The repetition index (0-indexed, i.e. the first repetition is at index 0)
     * @throws HL7Exception if the repetition requested is more than one 
     *     greater than the number of existing repetitions.
     */
    public OML_O33_TIMING_PRIOR getTIMING_PRIOR(int rep) { 
       OML_O33_TIMING_PRIOR ret = null;
       try {
          ret = (OML_O33_TIMING_PRIOR)this.get("TIMING_PRIOR", rep);
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error accessing data - this is probably a bug in the source code generator.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }

    /** 
     * Returns the number of existing repetitions of TIMING_PRIOR 
     */ 
    public int getTIMING_PRIORReps() { 
        int reps = -1; 
        try { 
            reps = this.getAll("TIMING_PRIOR").length; 
        } catch (HL7Exception e) { 
            String message = "Unexpected error accessing data - this is probably a bug in the source code generator."; 
            HapiLogFactory.getHapiLog(this.getClass()).error(message, e); 
            throw new RuntimeException(message);
        } 
        return reps; 
    } 

    /**
     * Inserts a specific repetition of TIMING_PRIOR (a Group object)
     * @see AbstractGroup#insertRepetition(Structure, int) 
     */
    public void insertTIMING_PRIOR(OML_O33_TIMING_PRIOR structure, int rep) throws HL7Exception { 
       super.insertRepetition("TIMING_PRIOR", structure, rep);
    }


    /**
     * Inserts a specific repetition of TIMING_PRIOR (a Group object)
     * @see AbstractGroup#insertRepetition(Structure, int) 
     */
    public OML_O33_TIMING_PRIOR insertTIMING_PRIOR(int rep) throws HL7Exception { 
       return (OML_O33_TIMING_PRIOR)super.insertRepetition("TIMING_PRIOR", rep);
    }


    /**
     * Removes a specific repetition of TIMING_PRIOR (a Group object)
     * @see AbstractGroup#removeRepetition(String, int) 
     */
    public OML_O33_TIMING_PRIOR removeTIMING_PRIOR(int rep) throws HL7Exception { 
       return (OML_O33_TIMING_PRIOR)super.removeRepetition("TIMING_PRIOR", rep);
    }



    /**
     * Returns
     * the first repetition of 
     * OBSERVATION_PRIOR (a Group object) - creates it if necessary
     */
    public OML_O33_OBSERVATION_PRIOR getOBSERVATION_PRIOR() { 
       OML_O33_OBSERVATION_PRIOR ret = null;
       try {
          ret = (OML_O33_OBSERVATION_PRIOR)this.get("OBSERVATION_PRIOR");
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error accessing data - this is probably a bug in the source code generator.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }


    /**
     * Returns a specific repetition of
     * OBSERVATION_PRIOR (a Group object) - creates it if necessary
     *
     * @param rep The repetition index (0-indexed, i.e. the first repetition is at index 0)
     * @throws HL7Exception if the repetition requested is more than one 
     *     greater than the number of existing repetitions.
     */
    public OML_O33_OBSERVATION_PRIOR getOBSERVATION_PRIOR(int rep) { 
       OML_O33_OBSERVATION_PRIOR ret = null;
       try {
          ret = (OML_O33_OBSERVATION_PRIOR)this.get("OBSERVATION_PRIOR", rep);
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error accessing data - this is probably a bug in the source code generator.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }

    /** 
     * Returns the number of existing repetitions of OBSERVATION_PRIOR 
     */ 
    public int getOBSERVATION_PRIORReps() { 
        int reps = -1; 
        try { 
            reps = this.getAll("OBSERVATION_PRIOR").length; 
        } catch (HL7Exception e) { 
            String message = "Unexpected error accessing data - this is probably a bug in the source code generator."; 
            HapiLogFactory.getHapiLog(this.getClass()).error(message, e); 
            throw new RuntimeException(message);
        } 
        return reps; 
    } 

    /**
     * Inserts a specific repetition of OBSERVATION_PRIOR (a Group object)
     * @see AbstractGroup#insertRepetition(Structure, int) 
     */
    public void insertOBSERVATION_PRIOR(OML_O33_OBSERVATION_PRIOR structure, int rep) throws HL7Exception { 
       super.insertRepetition("OBSERVATION_PRIOR", structure, rep);
    }


    /**
     * Inserts a specific repetition of OBSERVATION_PRIOR (a Group object)
     * @see AbstractGroup#insertRepetition(Structure, int) 
     */
    public OML_O33_OBSERVATION_PRIOR insertOBSERVATION_PRIOR(int rep) throws HL7Exception { 
       return (OML_O33_OBSERVATION_PRIOR)super.insertRepetition("OBSERVATION_PRIOR", rep);
    }


    /**
     * Removes a specific repetition of OBSERVATION_PRIOR (a Group object)
     * @see AbstractGroup#removeRepetition(String, int) 
     */
    public OML_O33_OBSERVATION_PRIOR removeOBSERVATION_PRIOR(int rep) throws HL7Exception { 
       return (OML_O33_OBSERVATION_PRIOR)super.removeRepetition("OBSERVATION_PRIOR", rep);
    }



}

